
_SoftWareUart_Init:

;softwareuart.c,1 :: 		void SoftWareUart_Init()
;softwareuart.c,3 :: 		SoftWare_Uart_Tx=1;
	BSF        SoftWare_Uart_Tx+0, BitPos(SoftWare_Uart_Tx+0)
;softwareuart.c,4 :: 		SoftWare_Uart_Rx=1;
	BSF        SoftWare_Uart_Rx+0, BitPos(SoftWare_Uart_Rx+0)
;softwareuart.c,5 :: 		SoftWare_Uart_Tx_Direction=0;
	BCF        SoftWare_Uart_Tx_Direction+0, BitPos(SoftWare_Uart_Tx_Direction+0)
;softwareuart.c,6 :: 		SoftWare_Uart_Rx_Direction=1;
	BSF        SoftWare_Uart_Rx_Direction+0, BitPos(SoftWare_Uart_Rx_Direction+0)
;softwareuart.c,8 :: 		SoftWare_Uart_Tx=1;//ensure idel state for standard
	BSF        SoftWare_Uart_Tx+0, BitPos(SoftWare_Uart_Tx+0)
;softwareuart.c,9 :: 		delay_us(BITPERIOD);
	MOVLW      84
	MOVWF      R13+0
L_SoftWareUart_Init0:
	DECFSZ     R13+0, 1
	GOTO       L_SoftWareUart_Init0
	NOP
	NOP
;softwareuart.c,10 :: 		}
L_end_SoftWareUart_Init:
	RETURN
; end of _SoftWareUart_Init

_Tx_Byte:

;softwareuart.c,13 :: 		void Tx_Byte(unsigned char Data)
;softwareuart.c,16 :: 		SoftWare_Uart_Tx = 0;//replace by one for inverted
	BCF        SoftWare_Uart_Tx+0, BitPos(SoftWare_Uart_Tx+0)
;softwareuart.c,17 :: 		delay_us(BITPERIOD);
	MOVLW      84
	MOVWF      R13+0
L_Tx_Byte1:
	DECFSZ     R13+0, 1
	GOTO       L_Tx_Byte1
	NOP
	NOP
;softwareuart.c,19 :: 		for (mask=0x01;mask!=0;mask=mask<<1)
	MOVLW      1
	MOVWF      R1+0
L_Tx_Byte2:
	MOVF       R1+0, 0
	XORLW      0
	BTFSC      STATUS+0, 2
	GOTO       L_Tx_Byte3
;softwareuart.c,21 :: 		if(Data&mask) SoftWare_Uart_Tx = 1;//replace by zero for inverted
	MOVF       R1+0, 0
	ANDWF      FARG_Tx_Byte_Data+0, 0
	MOVWF      R0+0
	BTFSC      STATUS+0, 2
	GOTO       L_Tx_Byte5
	BSF        SoftWare_Uart_Tx+0, BitPos(SoftWare_Uart_Tx+0)
	GOTO       L_Tx_Byte6
L_Tx_Byte5:
;softwareuart.c,22 :: 		else SoftWare_Uart_Tx = 0;//replace by one for inverted
	BCF        SoftWare_Uart_Tx+0, BitPos(SoftWare_Uart_Tx+0)
L_Tx_Byte6:
;softwareuart.c,23 :: 		delay_us(BITPERIOD);
	MOVLW      84
	MOVWF      R13+0
L_Tx_Byte7:
	DECFSZ     R13+0, 1
	GOTO       L_Tx_Byte7
	NOP
	NOP
;softwareuart.c,19 :: 		for (mask=0x01;mask!=0;mask=mask<<1)
	RLF        R1+0, 1
	BCF        R1+0, 0
;softwareuart.c,24 :: 		}
	GOTO       L_Tx_Byte2
L_Tx_Byte3:
;softwareuart.c,25 :: 		SoftWare_Uart_Tx = 1;//replace by zero for inverted
	BSF        SoftWare_Uart_Tx+0, BitPos(SoftWare_Uart_Tx+0)
;softwareuart.c,26 :: 		delay_us(BITPERIOD);
	MOVLW      84
	MOVWF      R13+0
L_Tx_Byte8:
	DECFSZ     R13+0, 1
	GOTO       L_Tx_Byte8
	NOP
	NOP
;softwareuart.c,27 :: 		}
L_end_Tx_Byte:
	RETURN
; end of _Tx_Byte

_Rx_Byte:

;softwareuart.c,29 :: 		unsigned char Rx_Byte()
;softwareuart.c,33 :: 		Data=0;
	CLRF       R2+0
;softwareuart.c,34 :: 		while(SoftWare_Uart_Rx);//replace by (!SoftWare_Uart_Rx) for inverted
L_Rx_Byte9:
	BTFSS      SoftWare_Uart_Rx+0, BitPos(SoftWare_Uart_Rx+0)
	GOTO       L_Rx_Byte10
	GOTO       L_Rx_Byte9
L_Rx_Byte10:
;softwareuart.c,35 :: 		delay_us(HALFBITPERIOD);
	MOVLW      42
	MOVWF      R13+0
L_Rx_Byte11:
	DECFSZ     R13+0, 1
	GOTO       L_Rx_Byte11
	NOP
;softwareuart.c,36 :: 		for(mask=0x01;mask!=0;mask=mask<<1)
	MOVLW      1
	MOVWF      R1+0
L_Rx_Byte12:
	MOVF       R1+0, 0
	XORLW      0
	BTFSC      STATUS+0, 2
	GOTO       L_Rx_Byte13
;softwareuart.c,38 :: 		delay_us(BITPERIOD);
	MOVLW      84
	MOVWF      R13+0
L_Rx_Byte15:
	DECFSZ     R13+0, 1
	GOTO       L_Rx_Byte15
	NOP
	NOP
;softwareuart.c,39 :: 		if(SoftWare_Uart_Rx)Data=Data|mask;//replace by (!SoftWare_Uart_Rx) for inverted
	BTFSS      SoftWare_Uart_Rx+0, BitPos(SoftWare_Uart_Rx+0)
	GOTO       L_Rx_Byte16
	MOVF       R1+0, 0
	IORWF      R2+0, 1
L_Rx_Byte16:
;softwareuart.c,36 :: 		for(mask=0x01;mask!=0;mask=mask<<1)
	RLF        R1+0, 1
	BCF        R1+0, 0
;softwareuart.c,40 :: 		}
	GOTO       L_Rx_Byte12
L_Rx_Byte13:
;softwareuart.c,41 :: 		Delay_us(BITPERIOD);
	MOVLW      84
	MOVWF      R13+0
L_Rx_Byte17:
	DECFSZ     R13+0, 1
	GOTO       L_Rx_Byte17
	NOP
	NOP
;softwareuart.c,42 :: 		return Data;
	MOVF       R2+0, 0
	MOVWF      R0+0
;softwareuart.c,43 :: 		}
L_end_Rx_Byte:
	RETURN
; end of _Rx_Byte

_SoftUart_Print:

;softwareuart.c,46 :: 		void SoftUart_Print(char* Text)
;softwareuart.c,48 :: 		while(*Text)Tx_Byte(*Text++);
L_SoftUart_Print18:
	MOVF       FARG_SoftUart_Print_Text+0, 0
	MOVWF      FSR
	MOVF       INDF+0, 0
	BTFSC      STATUS+0, 2
	GOTO       L_SoftUart_Print19
	MOVF       FARG_SoftUart_Print_Text+0, 0
	MOVWF      FSR
	MOVF       INDF+0, 0
	MOVWF      FARG_Tx_Byte_Data+0
	CALL       _Tx_Byte+0
	INCF       FARG_SoftUart_Print_Text+0, 1
	GOTO       L_SoftUart_Print18
L_SoftUart_Print19:
;softwareuart.c,49 :: 		}
L_end_SoftUart_Print:
	RETURN
; end of _SoftUart_Print

_SoftUart_PrintLine:

;softwareuart.c,52 :: 		void SoftUart_PrintLine(char* Text)
;softwareuart.c,54 :: 		while(*Text)Tx_Byte(*Text++);
L_SoftUart_PrintLine20:
	MOVF       FARG_SoftUart_PrintLine_Text+0, 0
	MOVWF      FSR
	MOVF       INDF+0, 0
	BTFSC      STATUS+0, 2
	GOTO       L_SoftUart_PrintLine21
	MOVF       FARG_SoftUart_PrintLine_Text+0, 0
	MOVWF      FSR
	MOVF       INDF+0, 0
	MOVWF      FARG_Tx_Byte_Data+0
	CALL       _Tx_Byte+0
	INCF       FARG_SoftUart_PrintLine_Text+0, 1
	GOTO       L_SoftUart_PrintLine20
L_SoftUart_PrintLine21:
;softwareuart.c,55 :: 		Tx_Byte('\r');Tx_Byte('\n');
	MOVLW      13
	MOVWF      FARG_Tx_Byte_Data+0
	CALL       _Tx_Byte+0
	MOVLW      10
	MOVWF      FARG_Tx_Byte_Data+0
	CALL       _Tx_Byte+0
;softwareuart.c,56 :: 		}
L_end_SoftUart_PrintLine:
	RETURN
; end of _SoftUart_PrintLine

_SoftUart_PrintConst:

;softwareuart.c,60 :: 		void SoftUart_PrintConst(const char* Text)
;softwareuart.c,62 :: 		while(*Text)Tx_Byte(*Text++);
L_SoftUart_PrintConst22:
	MOVF       FARG_SoftUart_PrintConst_Text+0, 0
	MOVWF      ___DoICPAddr+0
	MOVF       FARG_SoftUart_PrintConst_Text+1, 0
	MOVWF      ___DoICPAddr+1
	CALL       _____DoICP+0
	MOVWF      R0+0
	MOVF       R0+0, 0
	BTFSC      STATUS+0, 2
	GOTO       L_SoftUart_PrintConst23
	MOVF       FARG_SoftUart_PrintConst_Text+0, 0
	MOVWF      ___DoICPAddr+0
	MOVF       FARG_SoftUart_PrintConst_Text+1, 0
	MOVWF      ___DoICPAddr+1
	CALL       _____DoICP+0
	MOVWF      FARG_Tx_Byte_Data+0
	CALL       _Tx_Byte+0
	INCF       FARG_SoftUart_PrintConst_Text+0, 1
	BTFSC      STATUS+0, 2
	INCF       FARG_SoftUart_PrintConst_Text+1, 1
	GOTO       L_SoftUart_PrintConst22
L_SoftUart_PrintConst23:
;softwareuart.c,63 :: 		}
L_end_SoftUart_PrintConst:
	RETURN
; end of _SoftUart_PrintConst

_SoftUart_PrintConstLine:

;softwareuart.c,68 :: 		void SoftUart_PrintConstLine(const char* Text)
;softwareuart.c,70 :: 		while(*Text)Tx_Byte(*Text++);
L_SoftUart_PrintConstLine24:
	MOVF       FARG_SoftUart_PrintConstLine_Text+0, 0
	MOVWF      ___DoICPAddr+0
	MOVF       FARG_SoftUart_PrintConstLine_Text+1, 0
	MOVWF      ___DoICPAddr+1
	CALL       _____DoICP+0
	MOVWF      R0+0
	MOVF       R0+0, 0
	BTFSC      STATUS+0, 2
	GOTO       L_SoftUart_PrintConstLine25
	MOVF       FARG_SoftUart_PrintConstLine_Text+0, 0
	MOVWF      ___DoICPAddr+0
	MOVF       FARG_SoftUart_PrintConstLine_Text+1, 0
	MOVWF      ___DoICPAddr+1
	CALL       _____DoICP+0
	MOVWF      FARG_Tx_Byte_Data+0
	CALL       _Tx_Byte+0
	INCF       FARG_SoftUart_PrintConstLine_Text+0, 1
	BTFSC      STATUS+0, 2
	INCF       FARG_SoftUart_PrintConstLine_Text+1, 1
	GOTO       L_SoftUart_PrintConstLine24
L_SoftUart_PrintConstLine25:
;softwareuart.c,71 :: 		Tx_Byte('\r');Tx_Byte('\n');
	MOVLW      13
	MOVWF      FARG_Tx_Byte_Data+0
	CALL       _Tx_Byte+0
	MOVLW      10
	MOVWF      FARG_Tx_Byte_Data+0
	CALL       _Tx_Byte+0
;softwareuart.c,72 :: 		}
L_end_SoftUart_PrintConstLine:
	RETURN
; end of _SoftUart_PrintConstLine

_SoftUart_ScanText:

;softwareuart.c,78 :: 		void SoftUart_ScanText(char* Buffer, char StopChar)
;softwareuart.c,80 :: 		while(*(Buffer-1)!=StopChar)
L_SoftUart_ScanText26:
	DECF       FARG_SoftUart_ScanText_Buffer+0, 0
	MOVWF      FSR
	MOVF       INDF+0, 0
	XORWF      FARG_SoftUart_ScanText_StopChar+0, 0
	BTFSC      STATUS+0, 2
	GOTO       L_SoftUart_ScanText27
;softwareuart.c,82 :: 		*Buffer++=Rx_Byte();
	CALL       _Rx_Byte+0
	MOVF       FARG_SoftUart_ScanText_Buffer+0, 0
	MOVWF      FSR
	MOVF       R0+0, 0
	MOVWF      INDF+0
	INCF       FARG_SoftUart_ScanText_Buffer+0, 1
;softwareuart.c,83 :: 		}
	GOTO       L_SoftUart_ScanText26
L_SoftUart_ScanText27:
;softwareuart.c,84 :: 		*--Buffer='\0';
	DECF       FARG_SoftUart_ScanText_Buffer+0, 1
	MOVF       FARG_SoftUart_ScanText_Buffer+0, 0
	MOVWF      FSR
	CLRF       INDF+0
;softwareuart.c,85 :: 		}
L_end_SoftUart_ScanText:
	RETURN
; end of _SoftUart_ScanText

_SoftUart_PrintNChar:

;softwareuart.c,87 :: 		void SoftUart_PrintNChar(char* Buffer, char Size)
;softwareuart.c,90 :: 		for(i=0;i<Size;i++)
	CLRF       SoftUart_PrintNChar_i_L0+0
L_SoftUart_PrintNChar28:
	MOVF       FARG_SoftUart_PrintNChar_Size+0, 0
	SUBWF      SoftUart_PrintNChar_i_L0+0, 0
	BTFSC      STATUS+0, 0
	GOTO       L_SoftUart_PrintNChar29
;softwareuart.c,91 :: 		Tx_Byte(Buffer[i]);
	MOVF       SoftUart_PrintNChar_i_L0+0, 0
	ADDWF      FARG_SoftUart_PrintNChar_Buffer+0, 0
	MOVWF      FSR
	MOVF       INDF+0, 0
	MOVWF      FARG_Tx_Byte_Data+0
	CALL       _Tx_Byte+0
;softwareuart.c,90 :: 		for(i=0;i<Size;i++)
	INCF       SoftUart_PrintNChar_i_L0+0, 1
;softwareuart.c,91 :: 		Tx_Byte(Buffer[i]);
	GOTO       L_SoftUart_PrintNChar28
L_SoftUart_PrintNChar29:
;softwareuart.c,92 :: 		}
L_end_SoftUart_PrintNChar:
	RETURN
; end of _SoftUart_PrintNChar

_SoftUart_PrintNCharLine:

;softwareuart.c,94 :: 		void SoftUart_PrintNCharLine(char* Buffer, char Size)
;softwareuart.c,97 :: 		for(i=0;i<Size;i++)
	CLRF       SoftUart_PrintNCharLine_i_L0+0
L_SoftUart_PrintNCharLine31:
	MOVF       FARG_SoftUart_PrintNCharLine_Size+0, 0
	SUBWF      SoftUart_PrintNCharLine_i_L0+0, 0
	BTFSC      STATUS+0, 0
	GOTO       L_SoftUart_PrintNCharLine32
;softwareuart.c,98 :: 		Tx_Byte(Buffer[i]);
	MOVF       SoftUart_PrintNCharLine_i_L0+0, 0
	ADDWF      FARG_SoftUart_PrintNCharLine_Buffer+0, 0
	MOVWF      FSR
	MOVF       INDF+0, 0
	MOVWF      FARG_Tx_Byte_Data+0
	CALL       _Tx_Byte+0
;softwareuart.c,97 :: 		for(i=0;i<Size;i++)
	INCF       SoftUart_PrintNCharLine_i_L0+0, 1
;softwareuart.c,98 :: 		Tx_Byte(Buffer[i]);
	GOTO       L_SoftUart_PrintNCharLine31
L_SoftUart_PrintNCharLine32:
;softwareuart.c,100 :: 		Tx_Byte('\r');
	MOVLW      13
	MOVWF      FARG_Tx_Byte_Data+0
	CALL       _Tx_Byte+0
;softwareuart.c,101 :: 		Tx_Byte('\n');
	MOVLW      10
	MOVWF      FARG_Tx_Byte_Data+0
	CALL       _Tx_Byte+0
;softwareuart.c,102 :: 		}
L_end_SoftUart_PrintNCharLine:
	RETURN
; end of _SoftUart_PrintNCharLine

_SoftWareUart_GetChar:

;softwareuart.c,104 :: 		unsigned char SoftWareUart_GetChar()
;softwareuart.c,106 :: 		return Rx_Byte();
	CALL       _Rx_Byte+0
;softwareuart.c,107 :: 		}
L_end_SoftWareUart_GetChar:
	RETURN
; end of _SoftWareUart_GetChar

_SoftWareUart_PutChar:

;softwareuart.c,109 :: 		void SoftWareUart_PutChar(char DataByte)
;softwareuart.c,111 :: 		Tx_Byte(DataByte);
	MOVF       FARG_SoftWareUart_PutChar_DataByte+0, 0
	MOVWF      FARG_Tx_Byte_Data+0
	CALL       _Tx_Byte+0
;softwareuart.c,112 :: 		}
L_end_SoftWareUart_PutChar:
	RETURN
; end of _SoftWareUart_PutChar

_main:

;MyProject.c,17 :: 		void main()//start here
;MyProject.c,19 :: 		SoftWareUart_Init();//initialize software uart in idle state
	CALL       _SoftWareUart_Init+0
;MyProject.c,20 :: 		delay_ms(100);//wait a little to initialize
	MOVLW      2
	MOVWF      R11+0
	MOVLW      69
	MOVWF      R12+0
	MOVLW      169
	MOVWF      R13+0
L_main34:
	DECFSZ     R13+0, 1
	GOTO       L_main34
	DECFSZ     R12+0, 1
	GOTO       L_main34
	DECFSZ     R11+0, 1
	GOTO       L_main34
	NOP
	NOP
;MyProject.c,21 :: 		while(1)//infinit loop
L_main35:
;MyProject.c,23 :: 		SoftUart_ScanText(b,';');//read text character from uart
	MOVLW      _b+0
	MOVWF      FARG_SoftUart_ScanText_Buffer+0
	MOVLW      59
	MOVWF      FARG_SoftUart_ScanText_StopChar+0
	CALL       _SoftUart_ScanText+0
;MyProject.c,24 :: 		SoftUart_PrintLine(b); //print back the read text
	MOVLW      _b+0
	MOVWF      FARG_SoftUart_PrintLine_Text+0
	CALL       _SoftUart_PrintLine+0
;MyProject.c,25 :: 		}
	GOTO       L_main35
;MyProject.c,26 :: 		}
L_end_main:
	GOTO       $+0
; end of _main
