#include "SoftWareUart.h"


/*
Note : for changing the baudrate open the header "SoftWareUart.h" file and change the baudrate
then save and compile.
*/

sfr sbit SoftWare_Uart_Tx at RB0_bit;//tx pin
sfr sbit SoftWare_Uart_Rx at RB1_bit;//rx pin
sfr sbit SoftWare_Uart_Tx_Direction at TRISB0_bit;//tx direction
sfr sbit SoftWare_Uart_Rx_Direction at TRISB1_bit;//rx direction


char b[20];//character

void main()//start here
{
  SoftWareUart_Init();//initialize software uart in idle state
  delay_ms(100);//wait a little to initialize
  while(1)//infinit loop
  {
    SoftUart_ScanText(b,';');//read text character from uart
    SoftUart_PrintLine(b); //print back the read text
  }
}