#line 1 "C:/Documents and Settings/Nart Schinackow/Desktop/Software Uart Project/MyProject.c"
#line 1 "c:/documents and settings/nart schinackow/desktop/software uart project/softwareuart.h"
extern sfr sbit SoftWare_Uart_Tx;
extern sfr sbit SoftWare_Uart_Rx;
extern sfr sbit SoftWare_Uart_Tx_Direction;
extern sfr sbit SoftWare_Uart_Rx_Direction;
#line 1 "c:/documents and settings/nart schinackow/desktop/software uart project/softwareuart.c"
void SoftWareUart_Init()
{
 SoftWare_Uart_Tx=1;
 SoftWare_Uart_Rx=1;
 SoftWare_Uart_Tx_Direction=0;
 SoftWare_Uart_Rx_Direction=1;

 SoftWare_Uart_Tx=1;
 delay_us( ((1000000/ 9600 )-2) );
}


void Tx_Byte(unsigned char Data)
{
 char mask;
 SoftWare_Uart_Tx = 0;
 delay_us( ((1000000/ 9600 )-2) );

 for (mask=0x01;mask!=0;mask=mask<<1)
 {
 if(Data&mask) SoftWare_Uart_Tx = 1;
 else SoftWare_Uart_Tx = 0;
 delay_us( ((1000000/ 9600 )-2) );
 }
 SoftWare_Uart_Tx = 1;
 delay_us( ((1000000/ 9600 )-2) );
}

unsigned char Rx_Byte()
{
 char mask;
 char Data;
 Data=0;
 while(SoftWare_Uart_Rx);
 delay_us( ( ((1000000/ 9600 )-2) /2) );
 for(mask=0x01;mask!=0;mask=mask<<1)
 {
 delay_us( ((1000000/ 9600 )-2) );
 if(SoftWare_Uart_Rx)Data=Data|mask;
 }
 Delay_us( ((1000000/ 9600 )-2) );
 return Data;
}


void SoftUart_Print(char* Text)
{
 while(*Text)Tx_Byte(*Text++);
}


void SoftUart_PrintLine(char* Text)
{
 while(*Text)Tx_Byte(*Text++);
 Tx_Byte('\r');Tx_Byte('\n');
}



void SoftUart_PrintConst(const char* Text)
{
 while(*Text)Tx_Byte(*Text++);
}




void SoftUart_PrintConstLine(const char* Text)
{
 while(*Text)Tx_Byte(*Text++);
 Tx_Byte('\r');Tx_Byte('\n');
}





void SoftUart_ScanText(char* Buffer, char StopChar)
{
 while(*(Buffer-1)!=StopChar)
 {
 *Buffer++=Rx_Byte();
 }
 *--Buffer='\0';
}

void SoftUart_PrintNChar(char* Buffer, char Size)
{
 char i;
 for(i=0;i<Size;i++)
 Tx_Byte(Buffer[i]);
}

void SoftUart_PrintNCharLine(char* Buffer, char Size)
{
 char i;
 for(i=0;i<Size;i++)
 Tx_Byte(Buffer[i]);

 Tx_Byte('\r');
 Tx_Byte('\n');
}

unsigned char SoftWareUart_GetChar()
{
 return Rx_Byte();
}

void SoftWareUart_PutChar(char DataByte)
{
 Tx_Byte(DataByte);
}
#line 9 "C:/Documents and Settings/Nart Schinackow/Desktop/Software Uart Project/MyProject.c"
sfr sbit SoftWare_Uart_Tx at RB0_bit;
sfr sbit SoftWare_Uart_Rx at RB1_bit;
sfr sbit SoftWare_Uart_Tx_Direction at TRISB0_bit;
sfr sbit SoftWare_Uart_Rx_Direction at TRISB1_bit;


char b[20];

void main()
{
 SoftWareUart_Init();
 delay_ms(100);
 while(1)
 {
 SoftUart_ScanText(b,';');
 SoftUart_PrintLine(b);
 }
}
